#include <bits/stdc++.h>

using namespace std;


int main(){
        std::ios::sync_with_stdio(false);
	int n;
	while(cin >> n){
            int f;
            cin >> f;
            double last_filled = -1;
            
            vector<double> cap(n);
            vector<int> valves(n,1);
            vector<pair<double,int>> sorted_caps(n);
            vector<char> in_waterfall(n,false);
            vector<int> left_border(n);
            vector<int> parent(n);
            map<double,set<int>> waterfall;
            double passed_time = 0;
            for (int i = 0; i < n; i++) {
                cin >> cap[i];
                cap[i] /= f;
                left_border[i] = i;
                parent[i] = i+1;
                sorted_caps[i] = make_pair(cap[i],numeric_limits<int>::max()-i);
            }
            sort(sorted_caps.begin(), sorted_caps.end());
            
            for (int i = 0; i < n; i++) 
                 sorted_caps[i].second =  -(sorted_caps[i].second -numeric_limits<int>::max());

            int min_index = 0;
            int cap_iter = 0;
//            in_waterfall[sorted_caps[min_index]] = set<int>();
            while(cap_iter < n && sorted_caps[min_index].first == sorted_caps[cap_iter].first ){
                waterfall[sorted_caps[min_index].first].insert(cap_iter);
                in_waterfall[sorted_caps[cap_iter].second] = true;
                cap_iter++;
            }
            while(!waterfall.empty()){
                double min_watervalue = waterfall.begin()->first;
                set<int> min_waterset = waterfall.begin()->second;
//                if(min_watervalue == 0){
//                    
//                    waterfall.erase(min_watervalue);
//                    continue;
//                }
                double min_ordvalue = numeric_limits<double>::max();
                while(cap_iter < n && in_waterfall[sorted_caps[cap_iter].second])
                    cap_iter++;
                if(cap_iter < n )
                    min_ordvalue = sorted_caps[cap_iter].first-passed_time;
                if(min_watervalue<min_ordvalue){
                    waterfall.erase(min_watervalue);
                    passed_time += min_watervalue;
                    vector<int> arr;
                    for(auto v:min_waterset){
                        arr.push_back(v);
                    }
                    sort(arr.begin(),arr.end());
                    for(int i=arr.size()-1;i>=0;i--){
                        if(parent[arr[i]] != n){
                            int cur_parent = parent[arr[i]];
                            if(in_waterfall[cur_parent]){
                                waterfall.erase(cap[cur_parent]);
                                cap[cur_parent] = ((cap[cur_parent]-(min_watervalue/valves[arr[i]]))*valves[cur_parent]) / (valves[cur_parent] + valves[arr[i]]);
                                left_border[cur_parent] = left_border[arr[i]];
                                valves[cur_parent] += valves[arr[i]];
                                parent[left_border[cur_parent]] = cur_parent;
                                //in_waterfall[sorted_caps[min_index]] = set<int>();
                                if(cap[cur_parent] > 0 )
                                    waterfall[cap[cur_parent]].insert(cur_parent);
                            }else{
                                cap[cur_parent] = ((cap[cur_parent]-(min_watervalue/valves[arr[i]]))*valves[cur_parent]) / (valves[cur_parent] + valves[arr[i]]);
                                valves[cur_parent] += valves[arr[i]];
                                in_waterfall[cur_parent] = true;
                                left_border[cur_parent] = left_border[arr[i]];
                                parent[left_border[cur_parent]] = cur_parent;
                                //in_waterfall[sorted_caps[min_index]] = set<int>();
                                if(cap[cur_parent] > 0 )
                                    waterfall[cap[cur_parent]].insert(cur_parent);
                            }
                        }else if(parent[arr[i]] == n){
                            last_filled = passed_time;
                        }
                    }
                }else{
                    min_index = cap_iter;
                    passed_time += min_ordvalue;
                    while(cap_iter < n && sorted_caps[min_index].first == sorted_caps[cap_iter].first ){
                        waterfall[sorted_caps[min_index].first-passed_time].insert(min_index);
                        cap[sorted_caps[cap_iter].second] -= passed_time;
                        in_waterfall[sorted_caps[cap_iter].second] = true;
                        cap_iter++;
                    }
                }
            }
            cout << fixed << setprecision(10) << last_filled << " " << passed_time << endl;
	}
}